/***************************************************************************
 *   Authors:                                                              *
 *   - Nicolas Brodu                                                       *
 *                                                                         *
 *   Copyrights:                                                           *
 *   - INRIA                                                               *
 *   - Nicolas Brodu (initial base code, some modifications in SVN)        *
 *                                                                         *
 *   This file is free software; you can redistribute it and/or modify     *
 *   it under the terms of the GNU General Public License as               *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef CLASSIFIER_HyperMOG
#define CLASSIFIER_MultivariateStudentT

#include <itpp/itbase.h>

struct MultivariateStudentT {

    itpp::vec mean;
    itpp::mat precision; // inverse variance
    int dof;       // degrees of freedom

    double factorConstant;
    double powConstant;

    MultivariateStudentT() {}
    MultivariateStudentT(const itpp::vec& m, const itpp::mat& p, int d) : mean(m), precision(p), dof(d) {
        prepareForEstimation();
    }

    void prepareForEstimation();

    double logDensity(const itpp::vec& x);

    double density(const itpp::vec& x);


};

#endif
